# Go API client for swagger

Figshare apiv2. Using Swagger 2.0

## Overview
This API client was generated by the [swagger-codegen](https://github.com/swagger-api/swagger-codegen) project.  By using the [swagger-spec](https://github.com/swagger-api/swagger-spec) from a remote server, you can easily generate an API client.

- API version: 2.0.0
- Package version: 1.0.0
- Build package: io.swagger.codegen.languages.GoClientCodegen

## Installation
Put the package under your project folder and add the following in import:
```golang
import "./swagger"
```

## Documentation for API Endpoints

All URIs are relative to *https://api.figshare.com/v2*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*ArticlesApi* | [**AccountArticleReport**](docs/ArticlesApi.md#accountarticlereport) | **Get** /account/articles/export | Account Article Report
*ArticlesApi* | [**AccountArticleReportGenerate**](docs/ArticlesApi.md#accountarticlereportgenerate) | **Post** /account/articles/export | Initiate a new Report
*ArticlesApi* | [**ArticleDetails**](docs/ArticlesApi.md#articledetails) | **Get** /articles/{article_id} | View article details
*ArticlesApi* | [**ArticleFileDetails**](docs/ArticlesApi.md#articlefiledetails) | **Get** /articles/{article_id}/files/{file_id} | Article file details
*ArticlesApi* | [**ArticleFiles**](docs/ArticlesApi.md#articlefiles) | **Get** /articles/{article_id}/files | List article files
*ArticlesApi* | [**ArticleVersionConfidentiality**](docs/ArticlesApi.md#articleversionconfidentiality) | **Get** /articles/{article_id}/versions/{v_number}/confidentiality | Public Article Confidentiality for article version
*ArticlesApi* | [**ArticleVersionDetails**](docs/ArticlesApi.md#articleversiondetails) | **Get** /articles/{article_id}/versions/{v_number} | Article details for version
*ArticlesApi* | [**ArticleVersionEmbargo**](docs/ArticlesApi.md#articleversionembargo) | **Get** /articles/{article_id}/versions/{v_number}/embargo | Public Article Embargo for article version
*ArticlesApi* | [**ArticleVersionUpdate**](docs/ArticlesApi.md#articleversionupdate) | **Put** /account/articles/{article_id}/versions/{version_id}/ | Update article version
*ArticlesApi* | [**ArticleVersionUpdateThumb**](docs/ArticlesApi.md#articleversionupdatethumb) | **Put** /account/articles/{article_id}/versions/{version_id}/update_thumb | Update article version thumbnail
*ArticlesApi* | [**ArticleVersions**](docs/ArticlesApi.md#articleversions) | **Get** /articles/{article_id}/versions | List article versions
*ArticlesApi* | [**ArticlesList**](docs/ArticlesApi.md#articleslist) | **Get** /articles | Public Articles
*ArticlesApi* | [**ArticlesSearch**](docs/ArticlesApi.md#articlessearch) | **Post** /articles/search | Public Articles Search
*ArticlesApi* | [**PrivateArticleAuthorDelete**](docs/ArticlesApi.md#privatearticleauthordelete) | **Delete** /account/articles/{article_id}/authors/{author_id} | Delete article author
*ArticlesApi* | [**PrivateArticleAuthorsAdd**](docs/ArticlesApi.md#privatearticleauthorsadd) | **Post** /account/articles/{article_id}/authors | Add article authors
*ArticlesApi* | [**PrivateArticleAuthorsList**](docs/ArticlesApi.md#privatearticleauthorslist) | **Get** /account/articles/{article_id}/authors | List article authors
*ArticlesApi* | [**PrivateArticleAuthorsReplace**](docs/ArticlesApi.md#privatearticleauthorsreplace) | **Put** /account/articles/{article_id}/authors | Replace article authors
*ArticlesApi* | [**PrivateArticleCategoriesAdd**](docs/ArticlesApi.md#privatearticlecategoriesadd) | **Post** /account/articles/{article_id}/categories | Add article categories
*ArticlesApi* | [**PrivateArticleCategoriesList**](docs/ArticlesApi.md#privatearticlecategorieslist) | **Get** /account/articles/{article_id}/categories | List article categories
*ArticlesApi* | [**PrivateArticleCategoriesReplace**](docs/ArticlesApi.md#privatearticlecategoriesreplace) | **Put** /account/articles/{article_id}/categories | Replace article categories
*ArticlesApi* | [**PrivateArticleCategoryDelete**](docs/ArticlesApi.md#privatearticlecategorydelete) | **Delete** /account/articles/{article_id}/categories/{category_id} | Delete article category
*ArticlesApi* | [**PrivateArticleConfidentialityDelete**](docs/ArticlesApi.md#privatearticleconfidentialitydelete) | **Delete** /account/articles/{article_id}/confidentiality | Delete article confidentiality
*ArticlesApi* | [**PrivateArticleConfidentialityDetails**](docs/ArticlesApi.md#privatearticleconfidentialitydetails) | **Get** /account/articles/{article_id}/confidentiality | Article confidentiality details
*ArticlesApi* | [**PrivateArticleConfidentialityUpdate**](docs/ArticlesApi.md#privatearticleconfidentialityupdate) | **Put** /account/articles/{article_id}/confidentiality | Update article confidentiality
*ArticlesApi* | [**PrivateArticleCreate**](docs/ArticlesApi.md#privatearticlecreate) | **Post** /account/articles | Create new Article
*ArticlesApi* | [**PrivateArticleDelete**](docs/ArticlesApi.md#privatearticledelete) | **Delete** /account/articles/{article_id} | Delete article
*ArticlesApi* | [**PrivateArticleDetails**](docs/ArticlesApi.md#privatearticledetails) | **Get** /account/articles/{article_id} | Article details
*ArticlesApi* | [**PrivateArticleEmbargoDelete**](docs/ArticlesApi.md#privatearticleembargodelete) | **Delete** /account/articles/{article_id}/embargo | Delete Article Embargo
*ArticlesApi* | [**PrivateArticleEmbargoDetails**](docs/ArticlesApi.md#privatearticleembargodetails) | **Get** /account/articles/{article_id}/embargo | Article Embargo Details
*ArticlesApi* | [**PrivateArticleEmbargoUpdate**](docs/ArticlesApi.md#privatearticleembargoupdate) | **Put** /account/articles/{article_id}/embargo | Update Article Embargo
*ArticlesApi* | [**PrivateArticleFile**](docs/ArticlesApi.md#privatearticlefile) | **Get** /account/articles/{article_id}/files/{file_id} | Single File
*ArticlesApi* | [**PrivateArticleFileDelete**](docs/ArticlesApi.md#privatearticlefiledelete) | **Delete** /account/articles/{article_id}/files/{file_id} | File Delete
*ArticlesApi* | [**PrivateArticleFilesList**](docs/ArticlesApi.md#privatearticlefileslist) | **Get** /account/articles/{article_id}/files | List article files
*ArticlesApi* | [**PrivateArticlePrivateLink**](docs/ArticlesApi.md#privatearticleprivatelink) | **Get** /account/articles/{article_id}/private_links | List private links
*ArticlesApi* | [**PrivateArticlePrivateLinkCreate**](docs/ArticlesApi.md#privatearticleprivatelinkcreate) | **Post** /account/articles/{article_id}/private_links | Create private link
*ArticlesApi* | [**PrivateArticlePrivateLinkDelete**](docs/ArticlesApi.md#privatearticleprivatelinkdelete) | **Delete** /account/articles/{article_id}/private_links/{link_id} | Disable private link
*ArticlesApi* | [**PrivateArticlePrivateLinkUpdate**](docs/ArticlesApi.md#privatearticleprivatelinkupdate) | **Put** /account/articles/{article_id}/private_links/{link_id} | Update private link
*ArticlesApi* | [**PrivateArticlePublish**](docs/ArticlesApi.md#privatearticlepublish) | **Post** /account/articles/{article_id}/publish | Private Article Publish
*ArticlesApi* | [**PrivateArticleReserveDoi**](docs/ArticlesApi.md#privatearticlereservedoi) | **Post** /account/articles/{article_id}/reserve_doi | Private Article Reserve DOI
*ArticlesApi* | [**PrivateArticleReserveHandle**](docs/ArticlesApi.md#privatearticlereservehandle) | **Post** /account/articles/{article_id}/reserve_handle | Private Article Reserve Handle
*ArticlesApi* | [**PrivateArticleResource**](docs/ArticlesApi.md#privatearticleresource) | **Post** /account/articles/{article_id}/resource | Private Article Resource
*ArticlesApi* | [**PrivateArticleUpdate**](docs/ArticlesApi.md#privatearticleupdate) | **Put** /account/articles/{article_id} | Update article
*ArticlesApi* | [**PrivateArticleUploadComplete**](docs/ArticlesApi.md#privatearticleuploadcomplete) | **Post** /account/articles/{article_id}/files/{file_id} | Complete Upload
*ArticlesApi* | [**PrivateArticleUploadInitiate**](docs/ArticlesApi.md#privatearticleuploadinitiate) | **Post** /account/articles/{article_id}/files | Initiate Upload
*ArticlesApi* | [**PrivateArticlesList**](docs/ArticlesApi.md#privatearticleslist) | **Get** /account/articles | Private Articles
*ArticlesApi* | [**PrivateArticlesSearch**](docs/ArticlesApi.md#privatearticlessearch) | **Post** /account/articles/search | Private Articles search
*AuthorsApi* | [**PrivateAuthorDetails**](docs/AuthorsApi.md#privateauthordetails) | **Get** /account/authors/{author_id} | Author details
*AuthorsApi* | [**PrivateAuthorsSearch**](docs/AuthorsApi.md#privateauthorssearch) | **Post** /account/authors/search | Search Authors
*CollectionsApi* | [**CollectionArticles**](docs/CollectionsApi.md#collectionarticles) | **Get** /collections/{collection_id}/articles | Public Collection Articles
*CollectionsApi* | [**CollectionDetails**](docs/CollectionsApi.md#collectiondetails) | **Get** /collections/{collection_id} | Collection details
*CollectionsApi* | [**CollectionVersionDetails**](docs/CollectionsApi.md#collectionversiondetails) | **Get** /collections/{collection_id}/versions/{version_id} | Collection Version details
*CollectionsApi* | [**CollectionVersions**](docs/CollectionsApi.md#collectionversions) | **Get** /collections/{collection_id}/versions | Collection Versions list
*CollectionsApi* | [**CollectionsList**](docs/CollectionsApi.md#collectionslist) | **Get** /collections | Public Collections
*CollectionsApi* | [**CollectionsSearch**](docs/CollectionsApi.md#collectionssearch) | **Post** /collections/search | Public Collections Search
*CollectionsApi* | [**PrivateCollectionArticleDelete**](docs/CollectionsApi.md#privatecollectionarticledelete) | **Delete** /account/collections/{collection_id}/articles/{article_id} | Delete collection article
*CollectionsApi* | [**PrivateCollectionArticlesAdd**](docs/CollectionsApi.md#privatecollectionarticlesadd) | **Post** /account/collections/{collection_id}/articles | Add collection articles
*CollectionsApi* | [**PrivateCollectionArticlesList**](docs/CollectionsApi.md#privatecollectionarticleslist) | **Get** /account/collections/{collection_id}/articles | List collection articles
*CollectionsApi* | [**PrivateCollectionArticlesReplace**](docs/CollectionsApi.md#privatecollectionarticlesreplace) | **Put** /account/collections/{collection_id}/articles | Replace collection articles
*CollectionsApi* | [**PrivateCollectionAuthorDelete**](docs/CollectionsApi.md#privatecollectionauthordelete) | **Delete** /account/collections/{collection_id}/authors/{author_id} | Delete collection author
*CollectionsApi* | [**PrivateCollectionAuthorsAdd**](docs/CollectionsApi.md#privatecollectionauthorsadd) | **Post** /account/collections/{collection_id}/authors | Add collection authors
*CollectionsApi* | [**PrivateCollectionAuthorsList**](docs/CollectionsApi.md#privatecollectionauthorslist) | **Get** /account/collections/{collection_id}/authors | List collection authors
*CollectionsApi* | [**PrivateCollectionAuthorsReplace**](docs/CollectionsApi.md#privatecollectionauthorsreplace) | **Put** /account/collections/{collection_id}/authors | Replace collection authors
*CollectionsApi* | [**PrivateCollectionCategoriesAdd**](docs/CollectionsApi.md#privatecollectioncategoriesadd) | **Post** /account/collections/{collection_id}/categories | Add collection categories
*CollectionsApi* | [**PrivateCollectionCategoriesList**](docs/CollectionsApi.md#privatecollectioncategorieslist) | **Get** /account/collections/{collection_id}/categories | List collection categories
*CollectionsApi* | [**PrivateCollectionCategoriesReplace**](docs/CollectionsApi.md#privatecollectioncategoriesreplace) | **Put** /account/collections/{collection_id}/categories | Replace collection categories
*CollectionsApi* | [**PrivateCollectionCategoryDelete**](docs/CollectionsApi.md#privatecollectioncategorydelete) | **Delete** /account/collections/{collection_id}/categories/{category_id} | Delete collection category
*CollectionsApi* | [**PrivateCollectionCreate**](docs/CollectionsApi.md#privatecollectioncreate) | **Post** /account/collections | Create collection
*CollectionsApi* | [**PrivateCollectionDelete**](docs/CollectionsApi.md#privatecollectiondelete) | **Delete** /account/collections/{collection_id} | Delete collection
*CollectionsApi* | [**PrivateCollectionDetails**](docs/CollectionsApi.md#privatecollectiondetails) | **Get** /account/collections/{collection_id} | Collection details
*CollectionsApi* | [**PrivateCollectionPrivateLinkCreate**](docs/CollectionsApi.md#privatecollectionprivatelinkcreate) | **Post** /account/collections/{collection_id}/private_links | Create collection private link
*CollectionsApi* | [**PrivateCollectionPrivateLinkDelete**](docs/CollectionsApi.md#privatecollectionprivatelinkdelete) | **Delete** /account/collections/{collection_id}/private_links/{link_id} | Disable private link
*CollectionsApi* | [**PrivateCollectionPrivateLinkUpdate**](docs/CollectionsApi.md#privatecollectionprivatelinkupdate) | **Put** /account/collections/{collection_id}/private_links/{link_id} | Update collection private link
*CollectionsApi* | [**PrivateCollectionPrivateLinksList**](docs/CollectionsApi.md#privatecollectionprivatelinkslist) | **Get** /account/collections/{collection_id}/private_links | List collection private links
*CollectionsApi* | [**PrivateCollectionPublish**](docs/CollectionsApi.md#privatecollectionpublish) | **Post** /account/collections/{collection_id}/publish | Private Collection Publish
*CollectionsApi* | [**PrivateCollectionReserveDoi**](docs/CollectionsApi.md#privatecollectionreservedoi) | **Post** /account/collections/{collection_id}/reserve_doi | Private Collection Reserve DOI
*CollectionsApi* | [**PrivateCollectionReserveHandle**](docs/CollectionsApi.md#privatecollectionreservehandle) | **Post** /account/collections/{collection_id}/reserve_handle | Private Collection Reserve Handle
*CollectionsApi* | [**PrivateCollectionResource**](docs/CollectionsApi.md#privatecollectionresource) | **Post** /account/collections/{collection_id}/resource | Private Collection Resource
*CollectionsApi* | [**PrivateCollectionUpdate**](docs/CollectionsApi.md#privatecollectionupdate) | **Put** /account/collections/{collection_id} | Update collection
*CollectionsApi* | [**PrivateCollectionsList**](docs/CollectionsApi.md#privatecollectionslist) | **Get** /account/collections | Private Collections List
*CollectionsApi* | [**PrivateCollectionsSearch**](docs/CollectionsApi.md#privatecollectionssearch) | **Post** /account/collections/search | Private Collections Search
*InstitutionsApi* | [**AccountInstitutionCuration**](docs/InstitutionsApi.md#accountinstitutioncuration) | **Get** /account/institution/review/{curation_id} | Institution Curation Review
*InstitutionsApi* | [**AccountInstitutionCurationComments**](docs/InstitutionsApi.md#accountinstitutioncurationcomments) | **Get** /account/institution/review/{curation_id}/comments | Institution Curation Review Comments
*InstitutionsApi* | [**AccountInstitutionCurationComments_0**](docs/InstitutionsApi.md#accountinstitutioncurationcomments_0) | **Post** /account/institution/review/{curation_id}/comments | POST Institution Curation Review Comment
*InstitutionsApi* | [**AccountInstitutionCurations**](docs/InstitutionsApi.md#accountinstitutioncurations) | **Get** /account/institution/reviews | Institution Curation Reviews
*InstitutionsApi* | [**CustomFieldsList**](docs/InstitutionsApi.md#customfieldslist) | **Get** /account/institution/custom_fields | Private account institution group custom fields
*InstitutionsApi* | [**CustomFieldsUpload**](docs/InstitutionsApi.md#customfieldsupload) | **Post** /account/institution/custom_fields/{custom_field_id}/items/upload | Custom fields values files upload
*InstitutionsApi* | [**InstitutionArticles**](docs/InstitutionsApi.md#institutionarticles) | **Get** /institutions/{institution_string_id}/articles/filter-by | Public Institution Articles
*InstitutionsApi* | [**InstitutionHrfeedUpload**](docs/InstitutionsApi.md#institutionhrfeedupload) | **Post** /institution/hrfeed/upload | Private Institution HRfeed Upload
*InstitutionsApi* | [**PrivateAccountInstitutionUser**](docs/InstitutionsApi.md#privateaccountinstitutionuser) | **Get** /account/institution/users/{account_id} | Private Account Institution User
*InstitutionsApi* | [**PrivateCategoriesList**](docs/InstitutionsApi.md#privatecategorieslist) | **Get** /account/categories | Private Account Categories
*InstitutionsApi* | [**PrivateGroupEmbargoOptionsDetails**](docs/InstitutionsApi.md#privategroupembargooptionsdetails) | **Get** /account/institution/groups/{group_id}/embargo_options | Private Account Institution Group Embargo Options
*InstitutionsApi* | [**PrivateInstitutionAccountGroupRoleDelete**](docs/InstitutionsApi.md#privateinstitutionaccountgrouproledelete) | **Delete** /account/institution/roles/{account_id}/{group_id}/{role_id} | Delete Institution Account Group Role
*InstitutionsApi* | [**PrivateInstitutionAccountGroupRoles**](docs/InstitutionsApi.md#privateinstitutionaccountgrouproles) | **Get** /account/institution/roles/{account_id} | List Institution Account Group Roles
*InstitutionsApi* | [**PrivateInstitutionAccountGroupRolesCreate**](docs/InstitutionsApi.md#privateinstitutionaccountgrouprolescreate) | **Post** /account/institution/roles/{account_id} | Add Institution Account Group Roles
*InstitutionsApi* | [**PrivateInstitutionAccountsCreate**](docs/InstitutionsApi.md#privateinstitutionaccountscreate) | **Post** /account/institution/accounts | Create new Institution Account
*InstitutionsApi* | [**PrivateInstitutionAccountsList**](docs/InstitutionsApi.md#privateinstitutionaccountslist) | **Get** /account/institution/accounts | Private Account Institution Accounts
*InstitutionsApi* | [**PrivateInstitutionAccountsSearch**](docs/InstitutionsApi.md#privateinstitutionaccountssearch) | **Post** /account/institution/accounts/search | Private Account Institution Accounts Search
*InstitutionsApi* | [**PrivateInstitutionAccountsUpdate**](docs/InstitutionsApi.md#privateinstitutionaccountsupdate) | **Put** /account/institution/accounts/{account_id} | Update Institution Account
*InstitutionsApi* | [**PrivateInstitutionArticles**](docs/InstitutionsApi.md#privateinstitutionarticles) | **Get** /account/institution/articles | Private Institution Articles
*InstitutionsApi* | [**PrivateInstitutionDetails**](docs/InstitutionsApi.md#privateinstitutiondetails) | **Get** /account/institution | Private Account Institutions
*InstitutionsApi* | [**PrivateInstitutionEmbargoOptionsDetails**](docs/InstitutionsApi.md#privateinstitutionembargooptionsdetails) | **Get** /account/institution/embargo_options | Private Account Institution embargo options
*InstitutionsApi* | [**PrivateInstitutionGroupsList**](docs/InstitutionsApi.md#privateinstitutiongroupslist) | **Get** /account/institution/groups | Private Account Institution Groups
*InstitutionsApi* | [**PrivateInstitutionRolesList**](docs/InstitutionsApi.md#privateinstitutionroleslist) | **Get** /account/institution/roles | Private Account Institution Roles
*OtherApi* | [**CategoriesList**](docs/OtherApi.md#categorieslist) | **Get** /categories | Public Categories
*OtherApi* | [**FileDownload**](docs/OtherApi.md#filedownload) | **Get** /file/download/{file_id} | Public File Download
*OtherApi* | [**ItemTypesList**](docs/OtherApi.md#itemtypeslist) | **Get** /item_types | Item Types
*OtherApi* | [**LicensesList**](docs/OtherApi.md#licenseslist) | **Get** /licenses | Public Licenses
*OtherApi* | [**PrivateAccount**](docs/OtherApi.md#privateaccount) | **Get** /account | Private Account information
*OtherApi* | [**PrivateFundingSearch**](docs/OtherApi.md#privatefundingsearch) | **Post** /account/funding/search | Search Funding
*OtherApi* | [**PrivateLicensesList**](docs/OtherApi.md#privatelicenseslist) | **Get** /account/licenses | Private Account Licenses
*ProjectsApi* | [**PrivateProjectArticleDelete**](docs/ProjectsApi.md#privateprojectarticledelete) | **Delete** /account/projects/{project_id}/articles/{article_id} | Delete project article
*ProjectsApi* | [**PrivateProjectArticleDetails**](docs/ProjectsApi.md#privateprojectarticledetails) | **Get** /account/projects/{project_id}/articles/{article_id} | Project article details
*ProjectsApi* | [**PrivateProjectArticleFile**](docs/ProjectsApi.md#privateprojectarticlefile) | **Get** /account/projects/{project_id}/articles/{article_id}/files/{file_id} | Project article file details
*ProjectsApi* | [**PrivateProjectArticleFiles**](docs/ProjectsApi.md#privateprojectarticlefiles) | **Get** /account/projects/{project_id}/articles/{article_id}/files | Project article list files
*ProjectsApi* | [**PrivateProjectArticlesCreate**](docs/ProjectsApi.md#privateprojectarticlescreate) | **Post** /account/projects/{project_id}/articles | Create project article
*ProjectsApi* | [**PrivateProjectArticlesList**](docs/ProjectsApi.md#privateprojectarticleslist) | **Get** /account/projects/{project_id}/articles | List project articles
*ProjectsApi* | [**PrivateProjectCollaboratorDelete**](docs/ProjectsApi.md#privateprojectcollaboratordelete) | **Delete** /account/projects/{project_id}/collaborators/{user_id} | Remove project collaborator
*ProjectsApi* | [**PrivateProjectCollaboratorsInvite**](docs/ProjectsApi.md#privateprojectcollaboratorsinvite) | **Post** /account/projects/{project_id}/collaborators | Invite project collaborators
*ProjectsApi* | [**PrivateProjectCollaboratorsList**](docs/ProjectsApi.md#privateprojectcollaboratorslist) | **Get** /account/projects/{project_id}/collaborators | List project collaborators
*ProjectsApi* | [**PrivateProjectCreate**](docs/ProjectsApi.md#privateprojectcreate) | **Post** /account/projects | Create project
*ProjectsApi* | [**PrivateProjectDelete**](docs/ProjectsApi.md#privateprojectdelete) | **Delete** /account/projects/{project_id} | Delete project
*ProjectsApi* | [**PrivateProjectDetails**](docs/ProjectsApi.md#privateprojectdetails) | **Get** /account/projects/{project_id} | View project details
*ProjectsApi* | [**PrivateProjectLeave**](docs/ProjectsApi.md#privateprojectleave) | **Post** /account/projects/{project_id}/leave | Private Project Leave
*ProjectsApi* | [**PrivateProjectNote**](docs/ProjectsApi.md#privateprojectnote) | **Get** /account/projects/{project_id}/notes/{note_id} | Project note details
*ProjectsApi* | [**PrivateProjectNoteDelete**](docs/ProjectsApi.md#privateprojectnotedelete) | **Delete** /account/projects/{project_id}/notes/{note_id} | Delete project note
*ProjectsApi* | [**PrivateProjectNoteUpdate**](docs/ProjectsApi.md#privateprojectnoteupdate) | **Put** /account/projects/{project_id}/notes/{note_id} | Update project note
*ProjectsApi* | [**PrivateProjectNotesCreate**](docs/ProjectsApi.md#privateprojectnotescreate) | **Post** /account/projects/{project_id}/notes | Create project note
*ProjectsApi* | [**PrivateProjectNotesList**](docs/ProjectsApi.md#privateprojectnoteslist) | **Get** /account/projects/{project_id}/notes | List project notes
*ProjectsApi* | [**PrivateProjectPublish**](docs/ProjectsApi.md#privateprojectpublish) | **Post** /account/projects/{project_id}/publish | Private Project Publish
*ProjectsApi* | [**PrivateProjectUpdate**](docs/ProjectsApi.md#privateprojectupdate) | **Put** /account/projects/{project_id} | Update project
*ProjectsApi* | [**PrivateProjectsList**](docs/ProjectsApi.md#privateprojectslist) | **Get** /account/projects | Private Projects
*ProjectsApi* | [**PrivateProjectsSearch**](docs/ProjectsApi.md#privateprojectssearch) | **Post** /account/projects/search | Private Projects search
*ProjectsApi* | [**ProjectArticles**](docs/ProjectsApi.md#projectarticles) | **Get** /projects/{project_id}/articles | Public Project Articles
*ProjectsApi* | [**ProjectDetails**](docs/ProjectsApi.md#projectdetails) | **Get** /projects/{project_id} | Public Project
*ProjectsApi* | [**ProjectsList**](docs/ProjectsApi.md#projectslist) | **Get** /projects | Public Projects
*ProjectsApi* | [**ProjectsSearch**](docs/ProjectsApi.md#projectssearch) | **Post** /projects/search | Public Projects Search


## Documentation For Models

 - [Account](docs/Account.md)
 - [AccountCreate](docs/AccountCreate.md)
 - [AccountGroupRoles](docs/AccountGroupRoles.md)
 - [AccountGroupRolesCreate](docs/AccountGroupRolesCreate.md)
 - [AccountReport](docs/AccountReport.md)
 - [AccountUpdate](docs/AccountUpdate.md)
 - [Article](docs/Article.md)
 - [ArticleComplete](docs/ArticleComplete.md)
 - [ArticleCompletePrivate](docs/ArticleCompletePrivate.md)
 - [ArticleConfidentiality](docs/ArticleConfidentiality.md)
 - [ArticleCreate](docs/ArticleCreate.md)
 - [ArticleDoi](docs/ArticleDoi.md)
 - [ArticleEmbargo](docs/ArticleEmbargo.md)
 - [ArticleEmbargoUpdater](docs/ArticleEmbargoUpdater.md)
 - [ArticleHandle](docs/ArticleHandle.md)
 - [ArticleProjectCreate](docs/ArticleProjectCreate.md)
 - [ArticleSearch](docs/ArticleSearch.md)
 - [ArticleUpdate](docs/ArticleUpdate.md)
 - [ArticleVersions](docs/ArticleVersions.md)
 - [ArticleWithProject](docs/ArticleWithProject.md)
 - [ArticlesCreator](docs/ArticlesCreator.md)
 - [Author](docs/Author.md)
 - [AuthorComplete](docs/AuthorComplete.md)
 - [AuthorsCreator](docs/AuthorsCreator.md)
 - [CategoriesCreator](docs/CategoriesCreator.md)
 - [Category](docs/Category.md)
 - [Collaborator](docs/Collaborator.md)
 - [Collection](docs/Collection.md)
 - [CollectionComplete](docs/CollectionComplete.md)
 - [CollectionCompletePrivate](docs/CollectionCompletePrivate.md)
 - [CollectionCreate](docs/CollectionCreate.md)
 - [CollectionDoi](docs/CollectionDoi.md)
 - [CollectionHandle](docs/CollectionHandle.md)
 - [CollectionPrivateLinkCreator](docs/CollectionPrivateLinkCreator.md)
 - [CollectionSearch](docs/CollectionSearch.md)
 - [CollectionUpdate](docs/CollectionUpdate.md)
 - [CollectionVersions](docs/CollectionVersions.md)
 - [CommonSearch](docs/CommonSearch.md)
 - [ConfidentialityCreator](docs/ConfidentialityCreator.md)
 - [CreateProjectResponse](docs/CreateProjectResponse.md)
 - [Curation](docs/Curation.md)
 - [CurationComment](docs/CurationComment.md)
 - [CurationCommentCreate](docs/CurationCommentCreate.md)
 - [CurationDetail](docs/CurationDetail.md)
 - [CustomArticleField](docs/CustomArticleField.md)
 - [CustomArticleFieldAdd](docs/CustomArticleFieldAdd.md)
 - [ErrorMessage](docs/ErrorMessage.md)
 - [FileCreator](docs/FileCreator.md)
 - [FileId](docs/FileId.md)
 - [FundingCreate](docs/FundingCreate.md)
 - [FundingInformation](docs/FundingInformation.md)
 - [FundingSearch](docs/FundingSearch.md)
 - [Group](docs/Group.md)
 - [GroupEmbargoOptions](docs/GroupEmbargoOptions.md)
 - [Institution](docs/Institution.md)
 - [InstitutionAccountsSearch](docs/InstitutionAccountsSearch.md)
 - [ItemType](docs/ItemType.md)
 - [License](docs/License.md)
 - [Location](docs/Location.md)
 - [LocationWarnings](docs/LocationWarnings.md)
 - [LocationWarningsUpdate](docs/LocationWarningsUpdate.md)
 - [PrivateArticleSearch](docs/PrivateArticleSearch.md)
 - [PrivateAuthorsSearch](docs/PrivateAuthorsSearch.md)
 - [PrivateCollectionSearch](docs/PrivateCollectionSearch.md)
 - [PrivateFile](docs/PrivateFile.md)
 - [PrivateLink](docs/PrivateLink.md)
 - [PrivateLinkCreator](docs/PrivateLinkCreator.md)
 - [PrivateLinkResponse](docs/PrivateLinkResponse.md)
 - [Project](docs/Project.md)
 - [ProjectArticle](docs/ProjectArticle.md)
 - [ProjectCollaborator](docs/ProjectCollaborator.md)
 - [ProjectCollaboratorInvite](docs/ProjectCollaboratorInvite.md)
 - [ProjectComplete](docs/ProjectComplete.md)
 - [ProjectCompletePrivate](docs/ProjectCompletePrivate.md)
 - [ProjectCreate](docs/ProjectCreate.md)
 - [ProjectNote](docs/ProjectNote.md)
 - [ProjectNoteCreate](docs/ProjectNoteCreate.md)
 - [ProjectNotePrivate](docs/ProjectNotePrivate.md)
 - [ProjectPrivate](docs/ProjectPrivate.md)
 - [ProjectUpdate](docs/ProjectUpdate.md)
 - [ProjectsSearch](docs/ProjectsSearch.md)
 - [PublicFile](docs/PublicFile.md)
 - [RelatedMaterial](docs/RelatedMaterial.md)
 - [Resource](docs/Resource.md)
 - [ResponseMessage](docs/ResponseMessage.md)
 - [Role](docs/Role.md)
 - [ShortAccount](docs/ShortAccount.md)
 - [ShortCustomField](docs/ShortCustomField.md)
 - [Timeline](docs/Timeline.md)
 - [TimelineUpdate](docs/TimelineUpdate.md)
 - [UploadFilePart](docs/UploadFilePart.md)
 - [UploadInfo](docs/UploadInfo.md)
 - [User](docs/User.md)


## Documentation For Authorization

## OAuth2
- **Type**: OAuth
- **Flow**: accessCode
- **Authorization URL**: https://figshare.com/account/applications/authorize
- **Scopes**: 
 - **all**: Grants all access

Example
```golang
auth := context.WithValue(context.Background(), sw.ContextAccessToken, "ACCESSTOKENSTRING")
r, err := client.Service.Operation(auth, args)
```

Or via OAuth2 module to automatically refresh tokens and perform user authentication.
```golang
import "golang.org/x/oauth2"

/* Perform OAuth2 round trip request and obtain a token */

tokenSource := oauth2cfg.TokenSource(createContext(httpClient), &token)
auth := context.WithValue(oauth2.NoContext, sw.ContextOAuth2, tokenSource)
r, err := client.Service.Operation(auth, args)
```

## Author



