/*
 * Figshare API
 *
 * Figshare apiv2. Using Swagger 2.0
 *
 * API version: 2.0.0
 * Generated by: Swagger Codegen (https://github.com/swagger-api/swagger-codegen.git)
 */

package swagger

type ArticleCompletePrivate struct {
	// Article public url
	FigshareUrl string `json:"figshare_url,omitempty"`
	// If true, downloading of files for this article is disabled
	DownloadDisabled bool `json:"download_disabled,omitempty"`
	// List of article files
	Files []PublicFile `json:"files,omitempty"`
	// List of article authors
	Authors []Author `json:"authors,omitempty"`
	// List of custom fields values
	CustomFields []CustomArticleField `json:"custom_fields,omitempty"`
	// List of embargo options
	EmbargoOptions []GroupEmbargoOptions `json:"embargo_options,omitempty"`
	// Article citation
	Citation string `json:"citation,omitempty"`
	// Confidentiality reason
	ConfidentialReason string `json:"confidential_reason,omitempty"`
	// Article Confidentiality
	IsConfidential bool `json:"is_confidential,omitempty"`
	// Article size
	Size int64 `json:"size,omitempty"`
	// Article funding
	Funding string `json:"funding,omitempty"`
	// Full Article funding information
	FundingList []FundingInformation `json:"funding_list,omitempty"`
	// List of article tags
	Tags []string `json:"tags,omitempty"`
	// Article version
	Version int64 `json:"version,omitempty"`
	// True if article is active
	IsActive bool `json:"is_active,omitempty"`
	// True if article has no files
	IsMetadataRecord bool `json:"is_metadata_record,omitempty"`
	// Article metadata reason
	MetadataReason string `json:"metadata_reason,omitempty"`
	// Article status
	Status string `json:"status,omitempty"`
	// Article description
	Description string `json:"description,omitempty"`
	// True if article is embargoed
	IsEmbargoed bool `json:"is_embargoed,omitempty"`
	// True if article is published
	IsPublic bool `json:"is_public,omitempty"`
	// Date when article was created
	CreatedDate string `json:"created_date,omitempty"`
	// True if any files are linked to the article
	HasLinkedFile bool `json:"has_linked_file,omitempty"`
	// List of categories selected for the article
	Categories []Category `json:"categories,omitempty"`
	// Article selected license
	License *License `json:"license,omitempty"`
	// Title for embargo
	EmbargoTitle string `json:"embargo_title,omitempty"`
	// Reason for embargo
	EmbargoReason string `json:"embargo_reason,omitempty"`
	// List of references
	References []string `json:"references,omitempty"`
	// List of related materials; supersedes references and resource DOI/title.
	RelatedMaterials []RelatedMaterial `json:"related_materials,omitempty"`
	// Unique identifier for article
	Id int64 `json:"id"`
	// Title of article
	Title string `json:"title"`
	// DOI
	Doi string `json:"doi"`
	// Handle
	Handle string `json:"handle"`
	// Api endpoint for article
	Url string `json:"url"`
	// Public site endpoint for article
	UrlPublicHtml string `json:"url_public_html"`
	// Public Api endpoint for article
	UrlPublicApi string `json:"url_public_api"`
	// Private site endpoint for article
	UrlPrivateHtml string `json:"url_private_html"`
	// Private Api endpoint for article
	UrlPrivateApi string `json:"url_private_api"`
	// Various timeline dates
	Timeline *Timeline `json:"timeline"`
	// Thumbnail image
	Thumb string `json:"thumb"`
	// Type of article identifier
	DefinedType int64 `json:"defined_type"`
	// Name of the article type identifier
	DefinedTypeName string `json:"defined_type_name"`
	// ID of the account owning the article
	AccountId int64 `json:"account_id"`
}
