/*
 * Figshare API
 *
 * Figshare apiv2. Using Swagger 2.0
 *
 * API version: 2.0.0
 * Generated by: Swagger Codegen (https://github.com/swagger-api/swagger-codegen.git)
 */

package swagger

type CollectionCompletePrivate struct {
	// Collection id
	Id int64 `json:"id"`
	// Collection title
	Title string `json:"title"`
	// Collection DOI
	Doi string `json:"doi"`
	// Collection Handle
	Handle string `json:"handle"`
	// Api endpoint
	Url string `json:"url"`
	// Various timeline dates
	Timeline *Timeline `json:"timeline"`
	// ID of the account owning the collection
	AccountId int64 `json:"account_id"`
	// Full Collection funding information
	Funding []FundingInformation `json:"funding"`
	// Collection resource id
	ResourceId string `json:"resource_id"`
	// Collection resource doi
	ResourceDoi string `json:"resource_doi"`
	// Collection resource title
	ResourceTitle string `json:"resource_title"`
	// Collection resource link
	ResourceLink string `json:"resource_link"`
	// Collection resource version
	ResourceVersion int64 `json:"resource_version"`
	// Collection version
	Version int64 `json:"version"`
	// Collection description
	Description string `json:"description"`
	// List of collection categories
	Categories []Category `json:"categories"`
	// List of collection references
	References []string `json:"references"`
	// List of collection tags
	Tags []string `json:"tags"`
	// List of collection authors
	Authors []Author `json:"authors"`
	// Collection institution
	InstitutionId int64 `json:"institution_id"`
	// Collection group
	GroupId int64 `json:"group_id"`
	// Number of articles in collection
	ArticlesCount int64 `json:"articles_count"`
	// True if collection is published
	Public bool `json:"public"`
	// Collection citation
	Citation string `json:"citation"`
	// Collection custom fields
	CustomFields []CustomArticleField `json:"custom_fields"`
	// Date when collection was last modified
	ModifiedDate string `json:"modified_date"`
	// Date when collection was created
	CreatedDate string `json:"created_date"`
}
